/*
	File name:	chgvalpgm.c
	Type:		C main file.
	Author:		Gang Liu
	Date:		06/06/97
	Function:	Change specified pixel values to specified new values.
*/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "must.h"
#include "pgm.h"

void	usage(char *cmd);

int	main(int argc, char *argv[])
{
	char	op, verbose;
	uchar	oldval, newval;
	char	*fname;

	int	width, height;
	uchar	**image;

	int	i, j;
	long	count;

	if(argc<5) {
		usage(argv[0]);
		return -1;
	}

	verbose=0;
	if(argc>=6 && toupper(argv[5][0])=='V') verbose=1;

	oldval=atoi(argv[2]);
	newval=atoi(argv[3]);

	fname=argv[1];
	i=ReadPGM(fname, &width, &height, &image);
	if(i) myerror(-2, stderr, "Error reading input image.\n");

	count=0;
	for(i=0;i<height;i++)
		for(j=0;j<width;j++)
			if(image[i][j]==oldval) {
				image[i][j]=newval;
				count++;
			}

	fname=argv[4];
	i=WritePGM(fname, width, height, image);
	if(i) fprintf(stderr, "Error writing output.\n");

	if(verbose)
	printf("%d pixels changed from %d to %d.\n", count, oldval, newval);

	free2d((void**)image);

	if(i) i=-2;	/* signaling error in writing output file */
	return i;
}

void	usage(char *cmd)
{
fprintf(stderr, "Usage:\n\t %s <PGM1> <val1> <val2> <PGM2> [v]\n", cmd);
fprintf(stderr, "<PGM1> is input PGM file.\n");
fprintf(stderr, "<val1> is pixel value to be changed.\n");
fprintf(stderr, "<val2> is new pixel value to assign.\n");
fprintf(stderr, "<PGM2> is output PGM file.\n");
fprintf(stderr, "[v]    verbose.\n");
fprintf(stderr, "\n");
return;
}
