/*
	File name:	pickvalpgm.c
	Type:		C main file.
	Author:		Gang Liu
	Date:		06/06/97
	Function:	Get the bitmap of the pixels of a specified value.
*/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "must.h"
#include "pgm.h"

void	usage(char *cmd);

int	main(int argc, char *argv[])
{
	char	op, verbose;
	uchar	oldval, newval;
	char	*fname;

	int	width, height;
	uchar	**image;

	int	i, j;
	long	count;

	if(argc<4) {
		usage(argv[0]);
		return -1;
	}

	verbose=0;
	if(argc>=5 && toupper(argv[4][0])=='V') verbose=1;

	oldval=atoi(argv[2]);

	fname=argv[1];
	i=ReadPGM(fname, &width, &height, &image);
	if(i) myerror(-2, stderr, "Error reading input image.\n");

	count=0;
	for(i=0;i<height;i++)
		for(j=0;j<width;j++) {
			newval = ( (image[i][j]==oldval) ? 255 : 0 );
			image[i][j] = newval;
			if(newval) count++;
		}

	fname=argv[3];
	i=WritePGM(fname, width, height, image);
	if(i) fprintf(stderr, "Error writing output.\n");

	if(verbose)
		printf("%d pixels with value %d marked.\n", count, oldval);

	free2d((void**)image);

	if(i) i=-2;	/* signaling error in writing output file */
	return i;
}

void	usage(char *cmd)
{
fprintf(stderr, "Usage:\n\t %s <PGM1> <val> <PGM2> [v]\n", cmd);
fprintf(stderr, "<PGM1> is input PGM file.\n");
fprintf(stderr, "<val> is value of the pixels to be marked.\n");
fprintf(stderr, "<PGM2> is output PGM file.\n");
fprintf(stderr, "[v]    verbose.\n");
fprintf(stderr, "\n");
return;
}
